<template>
  <div class="dp" :class="{ 'dp-no-past-date': !allowPastDate }">
    <div class="dp-month-picker align-items-center">
      <div class="dp-month-action">
        <button class="dp-prev-btn" @click="increaseMonth(-1)">
          <i class="ic-sm-arrow"></i>
        </button>
      </div>
      <div class="flex-1">{{ year }} {{ month }}</div>
      <div class="dp-month-action">
        <button class="dp-next-btn" @click="increaseMonth(1)">
          <i class="ic-sm-arrow"></i>
        </button>
      </div>
    </div>
    <div class="dp-table">
      <div class="dp-week-names content-small">
        <div class="dp-week-name">{{ i18n["sun"] }}</div>
        <div class="dp-week-name">{{ i18n["mon"] }}</div>
        <div class="dp-week-name">{{ i18n["tue"] }}</div>
        <div class="dp-week-name">{{ i18n["wed"] }}</div>
        <div class="dp-week-name">{{ i18n["thu"] }}</div>
        <div class="dp-week-name">{{ i18n["fri"] }}</div>
        <div class="dp-week-name">{{ i18n["sat"] }}</div>
      </div>
      <div class="dp-days">
        <div
          class="dp-day"
          :class="{
            'dp-day--disabled': !isActive(d.format('YYYY-MM-DD')),
            'dp-day--past': today > d.toDate(),
            'dp-day--today': d.isSame(today),
            'dp-day--current': d.isSame(value)
          }"
          v-for="d in dates"
          :key="d.format('YYYY-MM-DD')"
        >
          <button
            class="dp-day-btn reset-btn"
            :disabled="!isActive(d.format('YYYY-MM-DD'))"
            @click="updateValue(d.format('YYYY-MM-DD'))"
          >
            {{ d.format("D") }}
          </button>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import moment from "moment";

const i18n = {
  "zh-TW": {
    sun: "週日",
    mon: "週一",
    tue: "週二",
    wed: "週三",
    thu: "週四",
    fri: "週五",
    sat: "週六"
  },
  "en-US": {
    sun: "Sun",
    mon: "Mon",
    tue: "Tue",
    wed: "Wed",
    thu: "Thu",
    fri: "Fri",
    sat: "Sat"
  }
};

export default {
  props: {
    value: {
      required: true
    },
    locale: {
      required: false,
      default: "zh-TW"
    },
    allowPastDate: {
      default: false
    },
    activeDate: {
      default: null
    }
  },
  watch: {
    locale() {
      this.m = moment(this.date);
      this.updateM();
    },
    date() {
      this.updateM();
    }
  },
  data() {
    return {
      date: this.value,
      m: moment(this.date),
      today: moment(new Date())
        .startOf("day")
        .toDate()
    };
  },
  computed: {
    i18n() {
      return i18n[this.locale];
    },
    year() {
      return this.m.format("YYYY");
    },
    month() {
      return this.m.format("MMM");
    },
    day() {
      return this.m.format("D");
    },
    dates() {
      const startOfMonth = this.m.startOf("month");

      const weekdayOfTheFirstDay = startOfMonth.isoWeekday() % 7;

      const m = moment(startOfMonth).subtract(weekdayOfTheFirstDay, "days");

      const daysInMonth = this.m.daysInMonth();
      const weeks = Math.ceil((daysInMonth + weekdayOfTheFirstDay) / 7);
      return Array.apply(null, { length: weeks * 7 }).map((_, i) =>
        moment(m).add(i, "days")
      );
    }
  },
  methods: {
    updateValue(newVal) {
      this.$emit("input", newVal);
      this.updateM(newVal);
    },
    increaseMonth(offset) {
      this.date = moment(this.date)
        .add(offset, "month")
        .toDate();
    },
    updateM(val) {
      this.m = moment(val || this.date);
    },
    isActive(date) {
      if (!this.activeDate) {
        return true;
      }
      return Boolean(this.activeDate[date]);
    }
  }
};
</script>
<style lang="scss">
.dp-month-picker {
  display: flex;
  margin: 0;
}
.dp {
  text-align: center;
  padding: 7px 5px;
}
.dp-week-names {
  display: flex;
  color: $color-secondary-black;
  line-height: 2;
}
.dp-week-name {
  flex: 1;
}
.dp-days {
  display: flex;
  flex-flow: row wrap;
}
.dp-day {
  flex: 1 1 14.2857142857%;
  overflow: hidden;
  align-items: center;
  justify-content: center;
  display: flex;
  position: relative;

  &--past {
    .dp-no-past-date & {
      cursor: not-allowed;
      pointer-events: none;
    }
  }

  &:before {
    content: "";
    float: left;
    padding-top: 100%;
  }
}

.dp-day-btn {
  position: absolute;
  left: 0;
  width: 100%;
  height: 100%;
  line-height: 100%;
  text-align: center;
  top: 0;
  padding: 0;
  color: $color-secondary-black;
  background-color: rgba($color-genesis-white, 0);

  .dp-day--past & {
    color: $color-pigeon-grey;
    background-color: $color-genesis-white;
  }
  .dp-day--today & {
    background-color: #ffe0e0;
  }
  .dp-day--current & {
    color: $color-white;
    background-color: $color-skm-red;
  }
  .dp-day--disabled & {
    color: $color-pigeon-grey;
    background-color: $color-genesis-white;
  }
}

.dp-month-action {
  width: 14.2857142857%;
}

.dp-prev-btn,
.dp-next-btn {
  cursor: pointer;
  font-size: 0.5em;
  padding: 15px;
  appearance: none;
  background: none;
  border: none;

  line-height: 1;
}
.dp-prev-btn {
  transform: rotate(90deg);
}
.dp-next-btn {
  transform: rotate(-90deg);
}
</style>
